
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>GC对吞吐量的影响 / iVAN</title>

    <meta name="description" content="GC对吞吐量的影响 英文原文链接,译文链接,原文作者:Nikita Salnikov-Tarnovski,译者:有孚 在看内存管理术语表的时候偶然发现了&quot;Pig in the Python(注:有点像中文里的贪心不足蛇吞象)&quot;的定义,于是便有了这篇文章.表面上看,这个术语说的是GC不停地将大对象从一个分代提升到另一个分代的情景.这么做就好比巨蟒整个吞食掉它的猎物,以至于它在消化的时候都没办法移动了. 在接下来的这24个小时里我的头脑中充斥着这个令人窒息的巨蟒的画面,挥之不去.正如精神病医生所说的 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">GC对吞吐量的影响</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><a href="https://plumbr.eu/blog/garbage-collection-increasing-the-throughput" rel="external nofollow noreferrer">英文原文链接</a>，<a href="http://ifeve.com/garbage-collection-increasing-the-throughput/%E2%80%8E" rel="external nofollow noreferrer">译文链接</a>，原文作者：Nikita Salnikov-Tarnovski，译者：有孚</p>
<p>在看<a href="http://www.memorymanagement.org/glossary/m.html#term-memory-management" rel="external nofollow noreferrer">内存管理术语表</a>的时候偶然发现了”<a href="http://www.memorymanagement.org/glossary/p.html#term-pig-in-the-python" rel="external nofollow noreferrer">Pig in the Python</a>（注：有点像中文里的贪心不足蛇吞象）”的定义，于是便有了这篇文章。表面上看，这个术语说的是GC不停地将大对象从一个分代提升到另一个分代的情景。这么做就好比巨蟒整个吞食掉它的猎物，以至于它在消化的时候都没办法移动了。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3BsdW1ici5ldS93cC1jb250ZW50L3VwbG9hZHMvMjAxNC8wOS9qYXZhLWdjLXBhdXNlLmpwZWc=.jpg"></p>
<p>在接下来的这24个小时里我的头脑中充斥着这个令人窒息的巨蟒的画面，挥之不去。正如精神病医生所说的，消除恐惧最好的方法就是说出来。于是便有了这篇文章。不过接下的故事我们要讲的不是蟒蛇，而是GC的调优。我对天发誓。</p>
<p>大家都知道GC暂停很容易造成性能瓶颈。现代JVM在发布的时候都自带了高级的垃圾回收器，不过从我的使用经验来看，要找出某个应用最优的配置真是难上加难。手动调优或许仍有一线希望，但是你得了解GC算法的确切机制才行。关于这点，本文倒是会对你有所帮助，下面我会通过一个例子来讲解JVM配置的一个小的改动是如何影响到你的应用程序的吞吐量的。</p>
<h2>示例</h2>
<p>我们用来演示GC对吞吐量产生影响的应用只是一个简单的程序。它包含两个线程：</p>
<ul>
<li>PigEater – 它会模仿巨蟒不停吞食大肥猪的过程。代码是通过往java.util.List中添加 32MB字节来实现这点的，每次吞食完后会睡眠100ms。</li>
<li>PigDigester – 它模拟异步消化的过程。实现消化的代码只是将猪的列表置为空。由于这是个很累的过程，因此每次清除完引用后这个线程都会睡眠2000ms。</li>
</ul>
<p>两个线程都会在一个while循环中运行，不停地吃了消化直到蛇吃饱为止。这大概得吃掉5000头猪。</p>
<pre><code>package eu.plumbr.demo;

public class PigInThePython {
  static volatile List pigs = new ArrayList();
  static volatile int pigsEaten = 0;
  static final int ENOUGH_PIGS = 5000;

  public static void main(String[] args) throws InterruptedException {
    new PigEater().start();
    new PigDigester().start();
  }

  static class PigEater extends Thread {

    @Override
    public void run() {
      while (true) {
        pigs.add(new byte[32 * 1024 * 1024]); //32MB per pig
        if (pigsEaten &gt; ENOUGH_PIGS) return;
        takeANap(100);
      }
    }
  }

  static class PigDigester extends Thread {
    @Override
    public void run() {
      long start = System.currentTimeMillis();

      while (true) {
        takeANap(2000);
        pigsEaten+=pigs.size();
        pigs = new ArrayList();
        if (pigsEaten &gt; ENOUGH_PIGS)  {
          System.out.format("Digested %d pigs in %d ms.%n",pigsEaten, System.currentTimeMillis()-start);
          return;
        }
      }
    }
  }

  static void takeANap(int ms) {
    try {
      Thread.sleep(ms);
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}
</code></pre>
<p>现在我们将这个系统的吞吐量定义为“每秒可以消化的猪的头数”。考虑到每100ms就会有猪被塞到这条蟒蛇里，我们可以看到这个系统理论上的最大吞吐量可以达到10头/秒。</p>
<h2>GC配置示例</h2>
<p>我们来看下使用两个不同的配置系统的表现分别是什么样的。不管是哪个配置，应用都运行在一台拥有双核，8GB内存的Mac（OS X10.9.3）上。</p>
<p>第一个配置：</p>
<ul>
<li>4G的堆（-Xms4g -Xmx4g）</li>
<li>使用CMS来清理老年代（-XX:+UseConcMarkSweepGC）使用并行回收器清理新生代（-XX:+UseParNewGC）</li>
<li>将堆的12.5%（-Xmn512m）分配给新生代，并将Eden区和Survivor区的大小限制为一样的。</li>
</ul>
<p>第二个配置则略有不同：</p>
<ul>
<li>2G的堆（-Xms2g -Xmx2g）</li>
<li>新生代和老年代都使用Parellel GC(-XX:+UseParallelGC)</li>
<li>将堆的75%分配给新生代（-Xmn 1536m）</li>
</ul>
<p>现在是该下注的时候了，哪个配置的表现会更好一些(就是每秒能吃多少猪，还记得吧)？那些把筹码放到第一个配置上的家伙，你们一定会失望的。结果正好相反：</p>
<ul>
<li>第一个配置（大堆，大的老年代，CMS GC）每秒能吞食8.2头猪</li>
<li>第二个配置（小堆，大的新生代，Parellel GC）每秒可以吞食9.2头猪</li>
</ul>
<p>现在我们来客观地看待一下这个结果。分配的资源少了2倍但吞吐量提升了12%。这和常识正好相反，因此有必要进一步分析下到底发生了什么。</p>
<h2>分析GC的结果</h2>
<p>原因其实并不复杂，你只要仔细看一下运行测试的时候GC在干什么就能发现答案了。这个你可以自己选择要使用的工具。在jstat的帮助下我发现了背后的秘密，命令大概是这样的：</p>
<p> </p>
<p>jstat -gc -t -h20 PID 1s</p>
<p> </p>
<p>通过分析数据，我注意到配置1经历了1129次GC周期（YGCT_FGCT），总共花了63.723秒：</p>
<pre><code>Timestamp        S0C    S1C    S0U    S1U      EC       EU        OC         OU       PC     PU    YGC     YGCT    FGC    FGCT     GCT
594.0 174720.0 174720.0 163844.1  0.0   174848.0 131074.1 3670016.0  2621693.5  21248.0 2580.9   1006   63.182  116 0.236   63.419
595.0 174720.0 174720.0 163842.1  0.0   174848.0 65538.0  3670016.0  3047677.9  21248.0 2580.9   1008   63.310  117 0.236   63.546
596.1 174720.0 174720.0 98308.0 163842.1 174848.0 163844.2 3670016.0   491772.9  21248.0 2580.9   1010   63.354  118 0.240   63.595
597.0 174720.0 174720.0  0.0   163840.1 174848.0 131074.1 3670016.0   688380.1  21248.0 2580.9   1011   63.482  118 0.240   63.723
</code></pre>
<p>第二个配置一共暂停了168次（YGCT+FGCT），只花了11.409秒。</p>
<pre><code>Timestamp        S0C    S1C    S0U    S1U      EC       EU        OC         OU       PC     PU    YGC     YGCT    FGC    FGCT     GCT
539.3 164352.0 164352.0  0.0    0.0   1211904.0 98306.0   524288.0   164352.2  21504.0 2579.2 27    2.969  141 8.441   11.409
540.3 164352.0 164352.0  0.0    0.0   1211904.0 425986.2  524288.0   164352.2  21504.0 2579.2 27    2.969  141 8.441   11.409
541.4 164352.0 164352.0  0.0    0.0   1211904.0 720900.4  524288.0   164352.2  21504.0 2579.2 27    2.969  141 8.441   11.409
542.3 164352.0 164352.0  0.0 0.0   1211904.0 1015812.6  524288.0   164352.2  21504.0 2579.2 27 2.969  141 8.441   11.409</code></pre>
<p>考虑到两种情况下的工作量是等同的，因此——在这个吃猪的实验中当GC没有发现长期存活的对象时，它能更快地清理掉垃圾对象。而采用第一个配置的话，GC运行的频率大概会是6到7倍之多，而总的暂停时间则是5至6倍。</p>
<p>说这个故事有两个目的。第一个也是最主要的一个，我希望把这条抽风的蟒蛇赶紧从我的脑海里赶出去。另一个更明显的收获就是——GC调优是个很需要技巧的经验活，它需要你对底层的这些概念了如指掌。尽管本文中用到的这个只是很平常的一个应用，但选择的不同结果也会对你的吞吐量和容量规划产生很大的影响。在现实生活中的应用里面，这里的区别则会更为巨大。因此，就看你如何抉择了，你可以去掌握这些概念，或者，只关注你日常的工作就好了，让Plumbr来找出你所需要的最合适的<a href="https://plumbr.eu/gc" rel="external nofollow noreferrer">GC配置</a>吧。</p>
<p>本文最早发表于我的个人博客<a href="http://it.deepinmind.com/gc/2014/09/22/garbage-collection-increasing-the-throughput.html%20target=" rel="external nofollow noreferrer">Java译站</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-17 14:58:53</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>GC对吞吐量的影响的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ2nqYz.html" rel="bookmark">Java中垃圾回收器GC对吞吐量的影响测试&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在看内存管理术语表的时候偶然发现了&quot;Pig in the Python(注:有点像中文里的贪心不足蛇吞象)&quot;的定义,于是便有了这篇文章.表面上看,这个术语说的是GC不停地将大对象从一个分代提升到另一个分代的情景.这么做就好比巨蟒整个吞食掉它的猎物,以至于它在消化的时候都没办法移动了. 在接下来的这24个小时里我的头脑中充斥着这个令人窒息的巨蟒的画面,挥之不去.正如精神病医生所说的,消除恐惧最好的方法就是说出来.于是便有了这篇文章.不过接下的故事我们要讲的不是蟒蛇,而是GC的调优.我对天			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/gpk2PEM.html" rel="bookmark">并发网2014&period;9月阅读量Top10</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				金秋已过,转眼又到了月底,并发网9月Top10的阅读量的文章新鲜送到,希望各位看官能喜欢!有任何意见和建议,欢迎告诉我们,我们在努力!~祝大家国庆节快乐 Top1 Java锁的种类以及辨析 锁作为并发共享数据,保证一致性的工具,在JAVA平台有多种实现(如 synchronized 和 ReentrantLock等等 ) .这些已经写好提供的锁为我们开发提供了便利,但是锁的具体性质以及类型却很少被提及--(2,047 人阅读) Top2 Java设计模式:策略模式 下面是一个有关于策略模式的故事			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQjZ3GM.html" rel="bookmark">一步步优化JVM六：优化吞吐量</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果你已经进行完了前面的步骤了,那么你应该知道这是最后一步了.在这一步里面,你需要测试应用的吞吐量和为了更高的吞吐量而优化JVM.    这一步的输入就是应用的吞吐量性能要求.应用的吞吐量是在应用层面衡量而不是在JVM层面衡量,因此,应用必须要报告出一些吞吐量指标或者应用的某些操作的吞吐量性能指标.观察到的吞吐量指标然后用可以用来和应用需要的性能指标进行比较,如果达到或者超过要求,那么这一步就完成了.如果你需要更好的吞吐量的话,有一些JVM优化可以去做.      这一步的另外一个输入就是,有多			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQwEJZp.html" rel="bookmark">浅谈关于Java的GC垃圾回收器的一些基本概念&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.基本回收算法 1. 引用计数(Reference Counting) 比较古老的回收算法.原理是此对象有一个引用,即增加一个计数,删除一个引用则减少一个计数.垃圾回收时,只用收集计数为0的对象.此算法最致命的是无法处理循环引用的问题. 2. 标记-清除(Mark-Sweep) 此算法执行分两阶段.第一阶段从引用根节点开始标记所有被引用的对象,第二阶段遍历整个堆,把未标记的对象清除.此算法需要暂停整个应用,同时,会产生内存碎片. 3. 复制(Copying) 此算法把内存空间划为两个相等的区域			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd6qOxb.html" rel="bookmark">jvm gc相关</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 杂类 http://www.oracle.com/technetwork/java/faq-140837.html  *    -XX:+UseParallelGC : 和传统的新生代GC一样,只是可以进行并行标记处理. 可通过-XX:ParallelGCThreads指定并发线程数,默认值:-XX:ParallelGCThreads =&lt;#cpus &lt; 8 ? #cpus : 3 + ((5 * #cpus) / 8) &gt; 1.The new parallel garbage c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZgZLOb.html" rel="bookmark">MSSQL &CenterDot; 实现分析 &CenterDot; Extend Event实现审计日志对SQL Server性能影响</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 在上一篇月报分享中,我们介绍了SQL Server实现审计日志功能的四种方法,最终的结论是使用Extend Event(中文叫扩展事件)实现审计日志方法是最优选择,详情参见MSSQL · 实现分析 · SQL Server实现审计日志的方案探索.那么,使用Extend Event实现审计日志的方案会面对如下疑问: Extend Event是否满足可靠性要求 Extend Event是否满足吞吐量要求 Extend Event对SQL Server本身语句查询性能影响到底有多大 这篇文章就是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgRY88b.html" rel="bookmark">优秀Java程序员必须了解的GC工作原理（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一个优秀的Java程序员必须了解GC(Garbage Collection 垃圾收集)的工作原理.如何优化GC的性能.如何与GC进行有限的交互,因为有一些应用程序对性能要求较高,例如嵌入式系统.实时系统等,只有全面提升内存的管理效率 ,才能提高整个应用程序的性能.本篇文章首先简单介绍GC的工作原理之后,然后再对GC的几个关键问题进行深入探讨,最后提出一些Java程序设计建议,从GC角度提高Java程序的性能. GC的基本原理 Java的内存管理实际上就是对象的管理,其中包括对象的分配和释放. 对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqWDvKz.html" rel="bookmark">从JVM的内存管理角度分析Java的GC垃圾回收机制&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一个优秀的Java程序员必须了解GC的工作原理.如何优化GC的性能.如何与GC进行有限的交互,因为有一些应用程序对性能要求较高,例如嵌入式系统.实时系统等,只有全面提升内存的管理效率 ,才能提高整个应用程序的性能.本篇文章首先简单介绍GC的工作原理之后,然后再对GC的几个关键问题进行深入探讨,最后提出一些Java程序设计建议,从GC角度提高Java程序的性能.    GC的基本原理    Java的内存管理实际上就是对象的管理,其中包括对象的分配和释放.     对于程序员来说,分配对象使用ne			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlOOXNb.html" rel="bookmark">jvm系列&lpar;十&rpar;&colon;如何优化Java GC「译」</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文由CrowHawk翻译,地址:如何优化Java GC「译」,是Java GC调优的经典佳作. Sangmin Lee发表在Cubrid上的&quot;Become a Java GC Expert&quot;系列文章的第三篇&lt;How to Tune Java Garbage Collection&gt;,本文的作者是韩国人,写在JDK 1.8发布之前,虽然有些地方有些许过时,但整体内容还是非常有价值的.译者此前也看到有人翻译了本文,发现其中有许多错漏生硬和语焉不详之处,因此决定自己翻译一份,供大			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2J6kb.html" rel="bookmark" class="title">Win7系统USB接口没反应怎么解决？</a>
					<div>
						  Win7系统USB接口没反应怎么解决? 1.首先打开设备管理器,找到对应设备: 2.按照网络上的办法,找到对应USB端口,据说每个设备对应着一串字符: 3.可是我怎么能记住那名字呢?还是用我的土办 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqo1Gz.html" rel="bookmark" class="title">配置Cisco PIX防火墙实现双出口</a>
					<div>
						一.用户需求 用户有一台Cisco PIX 515E防火墙,一个网通的出口,一个电信的出口.现在要实现默认都往电信线路出去,而访问网通的网站时使用网通的线路出去. 二.实现要点 1.首先要收集网通的I ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkENrb.html" rel="bookmark" class="title">问答方式帮你解决CSS网页制作中的基础问题</a>
					<div>
						css|解决|网页|问题 看一看下边这些CSS写法,是我在过去的时间里见过的一些问题,看你能猜对吗?你最好是先回复一下,说一说你认为的正确答案是什么!然后再看效是什么样的!  这样才有意思!都答对者, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgX68p.html" rel="bookmark" class="title">Flash AS创作：计算器</a>
					<div>
						动画演示效果: 点击这里下载源文件 码贴出来,省得大家去下载原文件! 帧上的AS: display = &quot;0&quot;; stop(); function getdigit(digit)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9Mxq2jp.html" rel="bookmark" class="title">在 ADO&period;NET 数据集中浏览多个相关表（5）</a>
					<div>
						ado|数据 创建关系      在 Solution Explorer(解决方案资源管理器)中,双击 dsNorthwind.xsd 文件.文件将在 XML Designer(XML 设计器)中打开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6239AM.html" rel="bookmark" class="title">快速排序算法的C语言实现</a>
					<div>
						经典的快速排序算法, 作为一个编程者, 任何时候都要完整的手写. 代码: /* * main.cpp * * Created on: 2014.6.12 * Author: Spike */ /*ec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj787ZM.html" rel="bookmark" class="title">Hadoop发行版运维利器：vSphere Big Data Extensions</a>
					<div>
						vSphere Big Data Extensions(BDE)提供了部署Hadoop多种厂商发行版的巨大灵活性,为客户提供三大价值: 为所支持的Hadoop版本提供调优的基础架构,VMware和Ha ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6a96z.html" rel="bookmark" class="title">Python的安装及环境配置</a>
					<div>
						1. 首先,通过wget下载Python安装包 [root@TDDBA ~]# wget http://www.python.org/ftp/python/2.7.3/Python-2.7.3.tgz ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jd7xb.html" rel="bookmark" class="title">access数据库连接出错&comma;请检查Conn&period;asp文件中的数据库参数</a>
					<div>
						  今天我们讲一个实际工作中遇到使用IIS建立网站出现:access数据库连接出错,请检查Conn.asp文件中的数据库参数设置的解决办法 1.路径设计错误,用记事本打开CONN.ASP, 如果是AC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1myWb.html" rel="bookmark" class="title">Excel技巧之对超过3列的数据排序</a>
					<div>
						  对于许多经常使用Excel排序功能的用户来说,&quot;排序&quot;对话框只允许一次性设置3个关键字的限制实在难以满足需要.在如图所示的工作表中,有一个 5列数据的表格,如果需要按从左向右为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWON3p.html" rel="bookmark" class="title">Win7旗舰版Windows安全中心打不开的解决方法</a>
					<div>
						在Win7旗舰版(www.xitonghe.com/win7/)的Windows安全中心中,有些一些跟系统安全相关的设置,如防火墙状态提示,自动更新提示,间谍软件提示等等,我们可以很方便的了解由安全中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqr5qb.html" rel="bookmark" class="title">推荐8款jQuery轻量级树形Tree插件&lowbar;jquery</a>
					<div>
						由于其拥有庞大,实用的插件库,使得jQuery变得越来越流行.今天将介绍一些最好的jQuery树形视图插件,具有扩展和可折叠的树视图.这些都是轻量级的,灵活的jQuery插件,它将一个无序列表转换为可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze66oVb.html" rel="bookmark" class="title">c&plus;&plus;-C&plus;&plus;使用Eigen库如何求解非方阵的广义逆矩阵？类似matlab的pinv函数</a>
					<div>
						问题描述 C++使用Eigen库如何求解非方阵的广义逆矩阵?类似matlab的pinv函数 C++使用Eigen库如何求解非方阵的广义逆矩阵?类似matlab的pinv函数? 运算量很大,所以必须使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjZnlp.html" rel="bookmark" class="title">redis-Redis和Memcache场景下效率对比</a>
					<div>
						问题描述 Redis和Memcache场景下效率对比 现在我做的是短信网关黑名单过滤机制,我每发一批短信,一批假如1000条, 这1000条数据都会从黑名单库中过一遍,目前我的黑名单是放在redis里 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lGXob.html" rel="bookmark" class="title">java serversocket-求java网络编程大牛的解决方案</a>
					<div>
						问题描述 求java网络编程大牛的解决方案 用java编写一个简单的Server,该Server接收Client发送过来的信息,并把接收到的信息输出到控制台,Client发送的信息是已经序列化的,为S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAA4vnM.html" rel="bookmark" class="title">上网&OpenCurlyDoubleQuote;自学成才&rdquo;制50余公斤冰毒</a>
					<div>
						□记者 赵磊 通讯员 曹小航 李青华 晨报讯 为偿还做生意欠下的高利贷债务,学化工出身的何俊在互联网上下载资料,&quot;自学成才&quot;学会了制作冰毒的方法.2009年9月至10月间,无论读大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAARy2M.html" rel="bookmark" class="title">iPhone6分辨率与适配</a>
					<div>
						iPhone6分辨率与适配 发布于:2014-09-12 10:35阅读数:15680 分辨率和像素 经新xcode6模拟器验证(分辨率为pt,像素为真实pixel): 1.iPhone5分辨率320 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydxAZb.html" rel="bookmark" class="title">c&plus;&plus;-大神问一下这个程序怎么写，谢谢 10&period;32</a>
					<div>
						问题描述 大神问一下这个程序怎么写,谢谢 10.32 解决方案 .................					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeAeJM.html" rel="bookmark" class="title">aspx。net中如何使用httpclient post传值并获取指定页面输出的success</a>
					<div>
						问题描述 如题,在A.ASPX中向B.aspx页面发送post信息,B.ASPX页面接受到数据后输出success.A.ASPX页面如何发送数据并获取B.ASPX页面中输出的success 解决方案  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoE69M.html" rel="bookmark" class="title">数据库连接问题：请问这是怎么回事？</a>
					<div>
						问题描述 在连接SQL2005时,出现这样的错误:System.Data.SqlClient.SqlException:Aconnectionwassuccessfullyestablishedwit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7Kl2z.html" rel="bookmark" class="title">《网络空间欺骗：构筑欺骗防御的科学基石》一2&period;4&period;3　实施和集成欺骗</a>
					<div>
						2.4.3 实施和集成欺骗 本文讲的是网络空间欺骗:构筑欺骗防御的科学基石一2.4.3 实施和集成欺骗,许多欺骗机制作为一个单独的与真实系统不相交的组件而实现,例如蜜罐.随着许多被恶意敌手和恶意软件所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GqnAp.html" rel="bookmark" class="title">JS中split&lpar;&rpar;用法（将字符串按指定符号分割成数组）&lowbar;javascript技巧</a>
					<div>
						废话不多说了,直接给大家贴代码. &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot;{CHARSET}&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKQYWM.html" rel="bookmark" class="title">JavaScript简单获取系统当前时间完整示例&lowbar;javascript技巧</a>
					<div>
						本文实例讲述了JavaScript简单获取系统当前时间的方法.分享给大家供大家参考,具体如下: 运行效果截图如下: 具体代码如下: &lt;!DOCTYPE html&gt; &lt;html xml ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWar8z.html" rel="bookmark" class="title">使用PDB简单调试Python程序简明指南&lowbar;python</a>
					<div>
						在 Python 中也可以像 gcc/gdb 那样调试程序,只要在运行 Python 程序时引入 pdb 模块(假设要调试的程序名为 d.py): 复制代码 代码如下: $ vi d.py #!/us ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWBDPz.html" rel="bookmark" class="title">android studio-Android studio 怎样导入eclipse项目</a>
					<div>
						问题描述 Android studio 怎样导入eclipse项目 提示这个,怎么解决! 解决方案 原文地址:http://www.ithao123.cn/content-2382286.html 现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEJYe3M.html" rel="bookmark" class="title">网购投诉元旦假期居于首位</a>
					<div>
						本报讯 (记者 陈玺撼)市工商局昨天公布的2013年元旦假期12315热线消费者申(投)诉举报情况显示,有关网购.通讯产品.食品3个方面的申(投)诉数量位居前三位. 节日期间,12315热线共受理网上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYdv6rb.html" rel="bookmark" class="title">iOS开发之UIDynamic</a>
					<div>
						1.概述 什么是UIDynamic? UIDynamic是从iOS 7开始引入的一种新技术,隶属于UIKit框架. 可以认为是一种物理引擎,能模拟和仿真现实生活中的物理现象.比如:重力.弹性碰撞等现象 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7wAwZz.html" rel="bookmark" class="title">网游私服案</a>
					<div>
						几名年轻人借助几台电脑,租赁远程服务器为他人架设&quot;热血传奇&quot;网游私服,从事私服广告代理活动,非法获利近100万元.山东省济南市市中区检察院近日以侵犯著作权罪依法批准逮捕了韩某等6名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVdZ8YM.html" rel="bookmark" class="title">港媒关注内地将斥资1800亿美元建全球最大5G移动网络</a>
					<div>
						中国三大电信运营商在5G基础设施上的总投入在七年内预计将达到1800亿美元,远远超出2013-2020年他们在4G网络上估计1170亿美元的投入. 据香港&lt;南华早报&gt;网站6月12日刊登题为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx2Vmyz.html" rel="bookmark" class="title">也要抢镜 谷歌企业协同工具</a>
					<div>
						随着苹果WWDC2016的开始,似乎各大巨头都在努力抢头条.前有微软收购LinkedIn,后有谷歌发布新产品.谷歌此次发布的产品主要针对企业级用户,被称为Springboard . 谷歌所推出的这款产 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
